#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define READ_SIZE 0x2000
#define NUM_TAGS 28

unsigned int format_now = 0;
unsigned int last_format = 0;

char *inbuf;
char *outbuf;
int insize;

char *tagbuf;
int tagcount;
int underline = 0;

int B_skip_count = 0;
int EM_skip_count = 0;
int I_skip_count = 0;
int PL_skip_count = 0;
int S_skip_count = 0;
int TT_skip_count = 0;
int U0_skip_count = 0;
int U1_skip_count = 0;
int U2_skip_count = 0;
int U3_skip_count = 0;
int N0_skip_count = 0;
int N1_skip_count = 0;
int N2_skip_count = 0;
int N3_skip_count = 0;
int N4_skip_count = 0;
int N5_skip_count = 0;
int N6_skip_count = 0;
int N7_skip_count = 0;
int N8_skip_count = 0;
int N9_skip_count = 0;
int r_skip_count = 0;
int g_skip_count = 0;
int b_skip_count = 0;
int c_skip_count = 0;
int m_skip_count = 0;
int y_skip_count = 0;
int k_skip_count = 0;
int w_skip_count = 0;

#define B_LEN 3
#define B_TAG 0
#define B_BIT 0x00000001
#define B_MASK 0xFFFFFFFE
#define EM_LEN 4
#define EM_TAG 1
#define EM_BIT 0x00000002
#define EM_MASK 0xFFFFFFFD
#define I_LEN 3
#define I_TAG 2
#define I_BIT 0x00000004
#define I_MASK 0xFFFFFFFB
#define PL_LEN 4
#define PL_TAG 3
#define PL_BIT 0x00000008
#define PL_MASK 0xFFFFFFF7
#define S_LEN 3
#define S_TAG 4
#define S_BIT 0x00000010
#define S_MASK 0xFFFFFFEF
#define TT_LEN 4
#define TT_TAG 5
#define TT_BIT 0x00000020
#define TT_MASK 0xFFFFFFDF
#define U0_LEN 3
#define U0_TAG 6
#define U0_BIT 0x00000040
#define U0_MASK 0xFFFFFFBF
#define U1_LEN 3
#define U1_TAG 7
#define U1_BIT 0x00000080
#define U1_MASK 0xFFFFFF7F
#define U2_LEN 3
#define U2_TAG 8
#define U2_BIT 0x00000100
#define U2_MASK 0xFFFFFEFF
#define U3_LEN 3
#define U3_TAG 9
#define U3_BIT 0x00000200
#define U3_MASK 0xFFFFFDFF
#define N0_LEN 3
#define N0_TAG 10
#define N0_BIT 0x00000400
#define N0_MASK 0xFFFFFBFF
#define N1_LEN 3
#define N1_TAG 11
#define N1_BIT 0x00000800
#define N1_MASK 0xFFFFF7FF
#define N2_LEN 3
#define N2_TAG 12
#define N2_BIT 0x00001000
#define N2_MASK 0xFFFFEFFF
#define N3_LEN 3
#define N3_TAG 13
#define N3_BIT 0x00002000
#define N3_MASK 0xFFFFDFFF
#define N4_LEN 3
#define N4_TAG 14
#define N4_BIT 0x00004000
#define N4_MASK 0xFFFFBFFF
#define N5_LEN 3
#define N5_TAG 15
#define N5_BIT 0x00008000
#define N5_MASK 0xFFFF7FFF
#define N6_LEN 3
#define N6_TAG 16
#define N6_BIT 0x00010000
#define N6_MASK 0xFFFEFFFF
#define N7_LEN 3
#define N7_TAG 17
#define N7_BIT 0x00020000
#define N7_MASK 0xFFFDFFFF
#define N8_LEN 3
#define N8_TAG 18
#define N8_BIT 0x00040000
#define N8_MASK 0xFFFBFFFF
#define N9_LEN 3
#define N9_TAG 19
#define N9_BIT 0x00080000
#define N9_MASK 0xFFF7FFFF
#define r_LEN 3
#define r_TAG 20
#define r_BIT 0x00100000
#define r_MASK 0xFFEFFFFF
#define g_LEN 3
#define g_TAG 21
#define g_BIT 0x00200000
#define g_MASK 0xFFDFFFFF
#define b_LEN 3
#define b_TAG 22
#define b_BIT 0x00400000
#define b_MASK 0xFFBFFFFF
#define c_LEN 3
#define c_TAG 23
#define c_BIT 0x00800000
#define c_MASK 0xFF7FFFFF
#define m_LEN 3
#define m_TAG 24
#define m_BIT 0x01000000
#define m_MASK 0xFEFFFFFF
#define y_LEN 3
#define y_TAG 25
#define y_BIT 0x02000000
#define y_MASK 0xFDFFFFFF
#define k_LEN 3
#define k_TAG 26
#define k_BIT 0x04000000
#define k_MASK 0xFBFFFFFF
#define w_LEN 3
#define w_TAG 27
#define w_BIT 0x08000000
#define w_MASK 0xF7FFFFFF

void add_tag(int which)
{
	switch (which)
	{
	case B_BIT:
		memcpy(outbuf,"<B>",B_LEN);
		outbuf += B_LEN;
		tagbuf[tagcount++] = B_TAG;
		break;
	case EM_BIT:
		memcpy(outbuf,"<EM>",EM_LEN);
		outbuf += EM_LEN;
		tagbuf[tagcount++] = EM_TAG;
		break;
	case I_BIT:
		memcpy(outbuf,"<I>",I_LEN);
		outbuf += I_LEN;
		tagbuf[tagcount++] = I_TAG;
		break;
	case PL_BIT:
		memcpy(outbuf,"<PL>",PL_LEN);
		outbuf += PL_LEN;
		tagbuf[tagcount++] = PL_TAG;
		break;
	case S_BIT:
		memcpy(outbuf,"<S>",S_LEN);
		outbuf += S_LEN;
		tagbuf[tagcount++] = S_TAG;
		break;
	case TT_BIT:
		memcpy(outbuf,"<TT>",TT_LEN);
		outbuf += TT_LEN;
		tagbuf[tagcount++] = TT_TAG;
		break;
	case U0_BIT:
		memcpy(outbuf,"<U>",U0_LEN);
		outbuf += U0_LEN;
		tagbuf[tagcount++] = U0_TAG;
		break;
	case U1_BIT:
		memcpy(outbuf,"<U>",U1_LEN);
		outbuf += U1_LEN;
		tagbuf[tagcount++] = U1_TAG;
		break;
	case U2_BIT:
		memcpy(outbuf,"<U>",U2_LEN);
		outbuf += U2_LEN;
		tagbuf[tagcount++] = U2_TAG;
		break;
	case U3_BIT:
		memcpy(outbuf,"<U>",U3_LEN);
		outbuf += U3_LEN;
		tagbuf[tagcount++] = U3_TAG;
		break;
	case N0_BIT:
		memcpy(outbuf,"<0>",N0_LEN);
		outbuf += N0_LEN;
		tagbuf[tagcount++] = N0_TAG;
		break;
	case N1_BIT:
		memcpy(outbuf,"<1>",N1_LEN);
		outbuf += N1_LEN;
		tagbuf[tagcount++] = N1_TAG;
		break;
	case N2_BIT:
		memcpy(outbuf,"<2>",N2_LEN);
		outbuf += N2_LEN;
		tagbuf[tagcount++] = N2_TAG;
		break;
	case N3_BIT:
		memcpy(outbuf,"<3>",N3_LEN);
		outbuf += N3_LEN;
		tagbuf[tagcount++] = N3_TAG;
		break;
	case N4_BIT:
		memcpy(outbuf,"<4>",N4_LEN);
		outbuf += N4_LEN;
		tagbuf[tagcount++] = N4_TAG;
		break;
	case N5_BIT:
		memcpy(outbuf,"<5>",N5_LEN);
		outbuf += N5_LEN;
		tagbuf[tagcount++] = N5_TAG;
		break;
	case N6_BIT:
		memcpy(outbuf,"<6>",N6_LEN);
		outbuf += N6_LEN;
		tagbuf[tagcount++] = N6_TAG;
		break;
	case N7_BIT:
		memcpy(outbuf,"<7>",N7_LEN);
		outbuf += N7_LEN;
		tagbuf[tagcount++] = N7_TAG;
		break;
	case N8_BIT:
		memcpy(outbuf,"<8>",N8_LEN);
		outbuf += N8_LEN;
		tagbuf[tagcount++] = N8_TAG;
		break;
	case N9_BIT:
		memcpy(outbuf,"<9>",N9_LEN);
		outbuf += N9_LEN;
		tagbuf[tagcount++] = N9_TAG;
		break;
	case r_BIT:
		memcpy(outbuf,"<r>",r_LEN);
		outbuf += r_LEN;
		tagbuf[tagcount++] = r_TAG;
		break;
	case g_BIT:
		memcpy(outbuf,"<g>",g_LEN);
		outbuf += g_LEN;
		tagbuf[tagcount++] = g_TAG;
		break;
	case b_BIT:
		memcpy(outbuf,"<b>",b_LEN);
		outbuf += b_LEN;
		tagbuf[tagcount++] = b_TAG;
		break;
	case c_BIT:
		memcpy(outbuf,"<c>",c_LEN);
		outbuf += c_LEN;
		tagbuf[tagcount++] = c_TAG;
		break;
	case m_BIT:
		memcpy(outbuf,"<m>",m_LEN);
		outbuf += m_LEN;
		tagbuf[tagcount++] = m_TAG;
		break;
	case y_BIT:
		memcpy(outbuf,"<y>",y_LEN);
		outbuf += y_LEN;
		tagbuf[tagcount++] = y_TAG;
		break;
	case k_BIT:
		memcpy(outbuf,"<k>",k_LEN);
		outbuf += k_LEN;
		tagbuf[tagcount++] = k_TAG;
		break;
	case w_BIT:
		memcpy(outbuf,"<w>",w_LEN);
		outbuf += w_LEN;
		tagbuf[tagcount++] = w_TAG;
		break;
	}
}

void on_tag(int which)
{
      switch (which)
      {
		case B_TAG:
			memcpy(outbuf,"<B>",3);
			outbuf += 3;
			break;
		case EM_TAG:
			memcpy(outbuf,"<EM>",4);
			outbuf += 4;
			break;
		case I_TAG:
			memcpy(outbuf,"<I>",3);
			outbuf += 3;
			break;
		case PL_TAG:
			memcpy(outbuf,"<PL>",4);
			outbuf += 4;
			break;
		case S_TAG:
			memcpy(outbuf,"<S>",3);
			outbuf += 3;
			break;
		case TT_TAG:
			memcpy(outbuf,"<TT>",4);
			outbuf += 4;
			break;
		case U0_TAG:
			memcpy(outbuf,"<U>",3);
			outbuf += 3;
			break;
		case U1_TAG:
			memcpy(outbuf,"<U>",3);
			outbuf += 3;
			break;
		case U2_TAG:
			memcpy(outbuf,"<U>",3);
			outbuf += 3;
			break;
		case U3_TAG:
			memcpy(outbuf,"<U>",3);
			outbuf += 3;
			break;
		case N0_TAG:
			memcpy(outbuf,"<0>",3);
			outbuf += 3;
			break;
		case N1_TAG:
			memcpy(outbuf,"<1>",3);
			outbuf += 3;
			break;
		case N2_TAG:
			memcpy(outbuf,"<2>",3);
			outbuf += 3;
			break;
		case N3_TAG:
			memcpy(outbuf,"<3>",3);
			outbuf += 3;
			break;
		case N4_TAG:
			memcpy(outbuf,"<4>",3);
			outbuf += 3;
			break;
		case N5_TAG:
			memcpy(outbuf,"<5>",3);
			outbuf += 3;
			break;
		case N6_TAG:
			memcpy(outbuf,"<6>",3);
			outbuf += 3;
			break;
		case N7_TAG:
			memcpy(outbuf,"<7>",3);
			outbuf += 3;
			break;
		case N8_TAG:
			memcpy(outbuf,"<8>",3);
			outbuf += 3;
			break;
		case N9_TAG:
			memcpy(outbuf,"<9>",3);
			outbuf += 3;
			break;
		case r_TAG:
			memcpy(outbuf,"<r>",3);
			outbuf += 3;
			break;
		case g_TAG:
			memcpy(outbuf,"<g>",3);
			outbuf += 3;
			break;
		case b_TAG:
			memcpy(outbuf,"<b>",3);
			outbuf += 3;
			break;
		case c_TAG:
			memcpy(outbuf,"<c>",3);
			outbuf += 3;
			break;
		case m_TAG:
			memcpy(outbuf,"<m>",3);
			outbuf += 3;
			break;
		case y_TAG:
			memcpy(outbuf,"<y>",3);
			outbuf += 3;
			break;
		case k_TAG:
			memcpy(outbuf,"<k>",3);
			outbuf += 3;
			break;
		case w_TAG:
			memcpy(outbuf,"<w>",3);
			outbuf += 3;
			break;
      }
}


void off_tag(int which)
{
      switch (which)
      {
		case B_TAG:
			memcpy(outbuf,"</B>",4);
			outbuf += 4;
			break;
		case EM_TAG:
			memcpy(outbuf,"</EM>",5);
			outbuf += 5;
			break;
		case I_TAG:
			memcpy(outbuf,"</I>",4);
			outbuf += 4;
			break;
		case PL_TAG:
			memcpy(outbuf,"</PL>",5);
			outbuf += 5;
			break;
		case S_TAG:
			memcpy(outbuf,"</S>",4);
			outbuf += 4;
			break;
		case TT_TAG:
			memcpy(outbuf,"</TT>",5);
			outbuf += 5;
			break;
		case U0_TAG:
			memcpy(outbuf,"</U>",4);
			outbuf += 4;
			break;
		case U1_TAG:
			memcpy(outbuf,"</U>",4);
			outbuf += 4;
			break;
		case U2_TAG:
			memcpy(outbuf,"</U>",4);
			outbuf += 4;
			break;
		case U3_TAG:
			memcpy(outbuf,"</U>",4);
			outbuf += 4;
			break;
		case N0_TAG:
			memcpy(outbuf,"</0>",4);
			outbuf += 4;
			break;
		case N1_TAG:
			memcpy(outbuf,"</1>",4);
			outbuf += 4;
			break;
		case N2_TAG:
			memcpy(outbuf,"</2>",4);
			outbuf += 4;
			break;
		case N3_TAG:
			memcpy(outbuf,"</3>",4);
			outbuf += 4;
			break;
		case N4_TAG:
			memcpy(outbuf,"</4>",4);
			outbuf += 4;
			break;
		case N5_TAG:
			memcpy(outbuf,"</5>",4);
			outbuf += 4;
			break;
		case N6_TAG:
			memcpy(outbuf,"</6>",4);
			outbuf += 4;
			break;
		case N7_TAG:
			memcpy(outbuf,"</7>",4);
			outbuf += 4;
			break;
		case N8_TAG:
			memcpy(outbuf,"</8>",4);
			outbuf += 4;
			break;
		case N9_TAG:
			memcpy(outbuf,"</9>",4);
			outbuf += 4;
			break;
		case r_TAG:
			memcpy(outbuf,"</r>",4);
			outbuf += 4;
			break;
		case g_TAG:
			memcpy(outbuf,"</g>",4);
			outbuf += 4;
			break;
		case b_TAG:
			memcpy(outbuf,"</b>",4);
			outbuf += 4;
			break;
		case c_TAG:
			memcpy(outbuf,"</c>",4);
			outbuf += 4;
			break;
		case m_TAG:
			memcpy(outbuf,"</m>",4);
			outbuf += 4;
			break;
		case y_TAG:
			memcpy(outbuf,"</y>",4);
			outbuf += 4;
			break;
		case k_TAG:
			memcpy(outbuf,"</k>",4);
			outbuf += 4;
			break;
		case w_TAG:
			memcpy(outbuf,"</w>",4);
			outbuf += 4;
			break;
      }
}

void drop_tag(int offset)
{
	int i;
	for (i = tagcount-offset-1; i < tagcount-1; i++)
	{
		tagbuf[i] = tagbuf[i+1];
	}
	tagcount--;
}

int main(int argc, char *argv[])
{
	int i;
	inbuf = NULL;
	insize = 0;
	while(!feof(stdin))
	{
		inbuf = (char *)realloc(inbuf,sizeof(char)*(insize+READ_SIZE*2));
		insize += fread(inbuf+insize+1,1,READ_SIZE,stdin);
	}
	inbuf[0] = 'x';
	inbuf[insize++] = 'y';
	inbuf[insize] = 0;
	int which = 0;
	outbuf = (char *)malloc(sizeof(char)*insize*5+READ_SIZE);
	outbuf[0] = 0;
	outbuf += 5;
	char *outstart = outbuf;
	char **changebuf = (char **)malloc(sizeof(char *)*insize);
	int changecount = 0;
	while (*inbuf)
	{
		if ((*inbuf < 33) && (*(outbuf-5) < 33) && !(format_now & 0x00000020))
		{
			inbuf++;
			continue;
		}
		if (*inbuf == '<')
		{
			inbuf++;
			if (*inbuf == '/')
			{
				inbuf++;
				switch(*inbuf)
				{
					case 'B':
						inbuf += 2;
						if (B_skip_count)  { B_skip_count--; break; }
						format_now &= 0xFFFFFFFE;
						break;
					case 'E':
						inbuf += 3;
						if (EM_skip_count)  { EM_skip_count--; break; }
						format_now ^= 0x00000002;
//						format_now &= 0xFFFFFFFD;
						break;
					case 'I':
						inbuf += 2;
						if (I_skip_count)  { I_skip_count--; break; }
						format_now &= 0xFFFFFFFB;
						break;
					case 'P':
						inbuf += 3;
						if (PL_skip_count)  { PL_skip_count--; break; }
						format_now &= 0xFFFFFFF7;
						break;
					case 'S':
						inbuf += 2;
						if (S_skip_count)  { S_skip_count--; break; }
						format_now &= 0xFFFFFFEF;
						break;
					case 'T':
						inbuf += 3;
						if (TT_skip_count)  { TT_skip_count--; break; }
						format_now &= 0xFFFFFFDF;
						break;
					case 'U':
						inbuf += 2;
						if (U0_skip_count)  { U0_skip_count--; break; }
						switch (underline)
						{
						case 0:
							format_now &= 0xFFFFFFBF;
							break;
						case 1:
							format_now &= 0xFFFFFF7F;
							break;
						case 2:
							format_now &= 0xFFFFFEFF;
							break;
						case 3:
							format_now &= 0xFFFFFDFF;
							break;
						}
						break;
#if 0
					case 'U':
						inbuf += 2;
						if (U1_skip_count)  { U1_skip_count--; break; }
						format_now &= 0xFFFFFF7F;
						break;
					case 'U':
						inbuf += 2;
						if (U2_skip_count)  { U2_skip_count--; break; }
						format_now &= 0xFFFFFEFF;
						break;
					case 'U':
						inbuf += 2;
						if (U3_skip_count)  { U3_skip_count--; break; }
						format_now &= 0xFFFFFDFF;
						break;
#endif
					case '0':
						inbuf += 2;
						if (N0_skip_count)  { N0_skip_count--; break; }
						format_now &= 0xFFFFFBFF;
						break;
					case '1':
						inbuf += 2;
						if (N1_skip_count)  { N1_skip_count--; break; }
						format_now &= 0xFFFFF7FF;
						break;
					case '2':
						inbuf += 2;
						if (N2_skip_count)  { N2_skip_count--; break; }
						format_now &= 0xFFFFEFFF;
						break;
					case '3':
						inbuf += 2;
						if (N3_skip_count)  { N3_skip_count--; break; }
						format_now &= 0xFFFFDFFF;
						break;
					case '4':
						inbuf += 2;
						if (N4_skip_count)  { N4_skip_count--; break; }
						format_now &= 0xFFFFBFFF;
						break;
					case '5':
						inbuf += 2;
						if (N5_skip_count)  { N5_skip_count--; break; }
						format_now &= 0xFFFF7FFF;
						break;
					case '6':
						inbuf += 2;
						if (N6_skip_count)  { N6_skip_count--; break; }
						format_now &= 0xFFFEFFFF;
						break;
					case '7':
						inbuf += 2;
						if (N7_skip_count)  { N7_skip_count--; break; }
						format_now &= 0xFFFDFFFF;
						break;
					case '8':
						inbuf += 2;
						if (N8_skip_count)  { N8_skip_count--; break; }
						format_now &= 0xFFFBFFFF;
						break;
					case '9':
						inbuf += 2;
						if (N9_skip_count)  { N9_skip_count--; break; }
						format_now &= 0xFFF7FFFF;
						break;
					case 'r':
						inbuf += 2;
						if (r_skip_count)  { r_skip_count--; break; }
						format_now &= 0xFFEFFFFF;
						break;
					case 'g':
						inbuf += 2;
						if (g_skip_count)  { g_skip_count--; break; }
						format_now &= 0xFFDFFFFF;
						break;
					case 'b':
						inbuf += 2;
						if (b_skip_count)  { b_skip_count--; break; }
						format_now &= 0xFFBFFFFF;
						break;
					case 'c':
						inbuf += 2;
						if (c_skip_count)  { c_skip_count--; break; }
						format_now &= 0xFF7FFFFF;
						break;
					case 'm':
						inbuf += 2;
						if (m_skip_count)  { m_skip_count--; break; }
						format_now &= 0xFEFFFFFF;
						break;
					case 'y':
						inbuf += 2;
						if (y_skip_count)  { y_skip_count--; break; }
						format_now &= 0xFDFFFFFF;
						break;
					case 'k':
						inbuf += 2;
						if (k_skip_count)  { k_skip_count--; break; }
						format_now &= 0xFBFFFFFF;
						break;
					case 'w':
						inbuf += 2;
						if (w_skip_count)  { w_skip_count--; break; }
						format_now &= 0xF7FFFFFF;
						break;
					}
			}

			else switch(*inbuf)
			{
				case 'B':
					inbuf += 2;
					if (format_now & 0x00000001) B_skip_count++;
					format_now |= 0x00000001;
					break;
				case 'E':
					inbuf += 3;
					if (format_now & 0x00000010)
					{
						EM_skip_count++;
						break;
					}
//					if (format_now & 0x00000002) EM_skip_count++;
					format_now ^= 0x00000002;
					break;
				case 'I':
					inbuf += 2;
					if (format_now & 0x00000004) I_skip_count++;
					format_now |= 0x00000004;
					break;
				case 'P':
					inbuf += 3;
					if (format_now & 0x00000008) PL_skip_count++;
					format_now |= 0x00000008;
					break;
				case 'S':
					inbuf += 2;
					if (format_now & 0x00000010) S_skip_count++;
					format_now |= 0x00000010;
					break;
				case 'T':
					inbuf += 3;
					if (format_now & 0x00000020) TT_skip_count++;
					format_now |= 0x00000020;
					break;
				case 'U':
					inbuf += 2;
					underline++;
					if (underline > 3) U0_skip_count++;
					switch (underline)
					{
					case 0:
						format_now |= 0x00000040;
						break;
					case 1:
						format_now |= 0x00000080;
						break;
					case 2:
						format_now |= 0x00000100;
						break;
					case 3:
						format_now |= 0x00000200;
						break;
					}
					break;
#if 0
				case 'U':
					inbuf += 2;
					if (format_now & 0x00000080) U1_skip_count++;
					format_now |= 0x00000080;
					break;
				case 'U':
					inbuf += 2;
					if (format_now & 0x00000100) U2_skip_count++;
					format_now |= 0x00000100;
					break;
				case 'U':
					inbuf += 2;
					if (format_now & 0x00000200) U3_skip_count++;
					format_now |= 0x00000200;
					break;
#endif
				case '0':
					inbuf += 2;
					if (format_now & 0x00000400) N0_skip_count++;
					format_now |= 0x00000400;
					break;
				case '1':
					inbuf += 2;
					if (format_now & 0x00000800) N1_skip_count++;
					format_now |= 0x00000800;
					break;
				case '2':
					inbuf += 2;
					if (format_now & 0x00001000) N2_skip_count++;
					format_now |= 0x00001000;
					break;
				case '3':
					inbuf += 2;
					if (format_now & 0x00002000) N3_skip_count++;
					format_now |= 0x00002000;
					break;
				case '4':
					inbuf += 2;
					if (format_now & 0x00004000) N4_skip_count++;
					format_now |= 0x00004000;
					break;
				case '5':
					inbuf += 2;
					if (format_now & 0x00008000) N5_skip_count++;
					format_now |= 0x00008000;
					break;
				case '6':
					inbuf += 2;
					if (format_now & 0x00010000) N6_skip_count++;
					format_now |= 0x00010000;
					break;
				case '7':
					inbuf += 2;
					if (format_now & 0x00020000) N7_skip_count++;
					format_now |= 0x00020000;
					break;
				case '8':
					inbuf += 2;
					if (format_now & 0x00040000) N8_skip_count++;
					format_now |= 0x00040000;
					break;
				case '9':
					inbuf += 2;
					if (format_now & 0x00080000) N9_skip_count++;
					format_now |= 0x00080000;
					break;
				case 'r':
					inbuf += 2;
					if (format_now & 0x00100000) r_skip_count++;
					format_now |= 0x00100000;
					break;
				case 'g':
					inbuf += 2;
					if (format_now & 0x00200000) g_skip_count++;
					format_now |= 0x00200000;
					break;
				case 'b':
					inbuf += 2;
					if (format_now & 0x00400000) b_skip_count++;
					format_now |= 0x00400000;
					break;
				case 'c':
					inbuf += 2;
					if (format_now & 0x00800000) c_skip_count++;
					format_now |= 0x00800000;
					break;
				case 'm':
					inbuf += 2;
					if (format_now & 0x01000000) m_skip_count++;
					format_now |= 0x01000000;
					break;
				case 'y':
					inbuf += 2;
					if (format_now & 0x02000000) y_skip_count++;
					format_now |= 0x02000000;
					break;
				case 'k':
					inbuf += 2;
					if (format_now & 0x04000000) k_skip_count++;
					format_now |= 0x04000000;
					break;
				case 'w':
					inbuf += 2;
					if (format_now & 0x08000000) w_skip_count++;
					format_now |= 0x08000000;
					break;
			}
		}
		else
		{
			if (format_now != last_format)
			{
				changebuf[changecount++] = outbuf;
			}
//		fprintf(stderr,"%c",*inbuf);
			*outbuf++ = *inbuf++;
			memcpy(outbuf,&format_now,4);
			outbuf += 4;
			last_format = format_now;
		}
	}
//	fprintf(stderr,"\n");
	*outbuf = 0;
	outbuf = inbuf;
	inbuf = outstart;
	outstart = outbuf;
	last_format = 0;
	tagbuf = (char *)malloc(sizeof(char)*insize);
	tagcount = 0;
	int bitcount,found;
	unsigned int bitchange;
	unsigned int stillon;
	unsigned int turnoff;
	unsigned int allchange;
	unsigned int nextchange;
	unsigned int nextoff;
	changebuf[changecount] = NULL;
	int tmpoff,skip;
	while (*inbuf)
	{
		if (inbuf == *changebuf)
		{
			changebuf++;
			found = 0;
			tmpoff = 0;
			format_now = *((unsigned int *)&(inbuf[1]));
			turnoff = (format_now ^ last_format) & last_format;
			if (turnoff) for (i = tagcount-1; ((i >= 0) && turnoff); i--)
			{
				skip = 0;
				switch(tagbuf[i])
				{
				case B_TAG:
					if (turnoff & 0x00000001)
					{
						last_format &= 0xFFFFFFFE;
						turnoff &= 0xFFFFFFFE;
						drop_tag(tmpoff);
						memcpy(outbuf,"</B>",4);
						outbuf += 4;
					}
					else skip = 1;
					break;
				case EM_TAG:
					if (turnoff & 0x00000002)
					{
						last_format &= 0xFFFFFFFD;
						turnoff &= 0xFFFFFFFD;
						drop_tag(tmpoff);
						memcpy(outbuf,"</EM>",5);
						outbuf += 5;
					}
					else skip = 1;
					break;
				case I_TAG:
					if (turnoff & 0x00000004)
					{
						last_format &= 0xFFFFFFFB;
						turnoff &= 0xFFFFFFFB;
						drop_tag(tmpoff);
						memcpy(outbuf,"</I>",4);
						outbuf += 4;
					}
					else skip = 1;
					break;
				case PL_TAG:
					if (turnoff & 0x00000008)
					{
						last_format &= 0xFFFFFFF7;
						turnoff &= 0xFFFFFFF7;
						drop_tag(tmpoff);
						memcpy(outbuf,"</PL>",5);
						outbuf += 5;
					}
					else skip = 1;
					break;
				case S_TAG:
					if (turnoff & 0x00000010)
					{
						last_format &= 0xFFFFFFEF;
						turnoff &= 0xFFFFFFEF;
						drop_tag(tmpoff);
						memcpy(outbuf,"</S>",4);
						outbuf += 4;
					}
					else skip = 1;
					break;
				case TT_TAG:
					if (turnoff & 0x00000020)
					{
						last_format &= 0xFFFFFFDF;
						turnoff &= 0xFFFFFFDF;
						drop_tag(tmpoff);
						memcpy(outbuf,"</TT>",5);
						outbuf += 5;
					}
					else skip = 1;
					break;
				case U0_TAG:
					if (turnoff & 0x00000040)
					{
						last_format &= 0xFFFFFFBF;
						turnoff &= 0xFFFFFFBF;
						drop_tag(tmpoff);
						memcpy(outbuf,"</U>",4);
						outbuf += 4;
					}
					else skip = 1;
					break;
				case U1_TAG:
					if (turnoff & 0x00000080)
					{
						last_format &= 0xFFFFFF7F;
						turnoff &= 0xFFFFFF7F;
						drop_tag(tmpoff);
						memcpy(outbuf,"</U>",4);
						outbuf += 4;
					}
					else skip = 1;
					break;
				case U2_TAG:
					if (turnoff & 0x00000100)
					{
						last_format &= 0xFFFFFEFF;
						turnoff &= 0xFFFFFEFF;
						drop_tag(tmpoff);
						memcpy(outbuf,"</U>",4);
						outbuf += 4;
					}
					else skip = 1;
					break;
				case U3_TAG:
					if (turnoff & 0x00000200)
					{
						last_format &= 0xFFFFFDFF;
						turnoff &= 0xFFFFFDFF;
						drop_tag(tmpoff);
						memcpy(outbuf,"</U>",4);
						outbuf += 4;
					}
					else skip = 1;
					break;
				case N0_TAG:
					if (turnoff & 0x00000400)
					{
						last_format &= 0xFFFFFBFF;
						turnoff &= 0xFFFFFBFF;
						drop_tag(tmpoff);
						memcpy(outbuf,"</0>",4);
						outbuf += 4;
					}
					else skip = 1;
					break;
				case N1_TAG:
					if (turnoff & 0x00000800)
					{
						last_format &= 0xFFFFF7FF;
						turnoff &= 0xFFFFF7FF;
						drop_tag(tmpoff);
						memcpy(outbuf,"</1>",4);
						outbuf += 4;
					}
					else skip = 1;
					break;
				case N2_TAG:
					if (turnoff & 0x00001000)
					{
						last_format &= 0xFFFFEFFF;
						turnoff &= 0xFFFFEFFF;
						drop_tag(tmpoff);
						memcpy(outbuf,"</2>",4);
						outbuf += 4;
					}
					else skip = 1;
					break;
				case N3_TAG:
					if (turnoff & 0x00002000)
					{
						last_format &= 0xFFFFDFFF;
						turnoff &= 0xFFFFDFFF;
						drop_tag(tmpoff);
						memcpy(outbuf,"</3>",4);
						outbuf += 4;
					}
					else skip = 1;
					break;
				case N4_TAG:
					if (turnoff & 0x00004000)
					{
						last_format &= 0xFFFFBFFF;
						turnoff &= 0xFFFFBFFF;
						drop_tag(tmpoff);
						memcpy(outbuf,"</4>",4);
						outbuf += 4;
					}
					else skip = 1;
					break;
				case N5_TAG:
					if (turnoff & 0x00008000)
					{
						last_format &= 0xFFFF7FFF;
						turnoff &= 0xFFFF7FFF;
						drop_tag(tmpoff);
						memcpy(outbuf,"</5>",4);
						outbuf += 4;
					}
					else skip = 1;
					break;
				case N6_TAG:
					if (turnoff & 0x00010000)
					{
						last_format &= 0xFFFEFFFF;
						turnoff &= 0xFFFEFFFF;
						drop_tag(tmpoff);
						memcpy(outbuf,"</6>",4);
						outbuf += 4;
					}
					else skip = 1;
					break;
				case N7_TAG:
					if (turnoff & 0x00020000)
					{
						last_format &= 0xFFFDFFFF;
						turnoff &= 0xFFFDFFFF;
						drop_tag(tmpoff);
						memcpy(outbuf,"</7>",4);
						outbuf += 4;
					}
					else skip = 1;
					break;
				case N8_TAG:
					if (turnoff & 0x00040000)
					{
						last_format &= 0xFFFBFFFF;
						turnoff &= 0xFFFBFFFF;
						drop_tag(tmpoff);
						memcpy(outbuf,"</8>",4);
						outbuf += 4;
					}
					else skip = 1;
					break;
				case N9_TAG:
					if (turnoff & 0x00080000)
					{
						last_format &= 0xFFF7FFFF;
						turnoff &= 0xFFF7FFFF;
						drop_tag(tmpoff);
						memcpy(outbuf,"</9>",4);
						outbuf += 4;
					}
					else skip = 1;
					break;
				case r_TAG:
					if (turnoff & 0x00100000)
					{
						last_format &= 0xFFEFFFFF;
						turnoff &= 0xFFEFFFFF;
						drop_tag(tmpoff);
						memcpy(outbuf,"</r>",4);
						outbuf += 4;
					}
					else skip = 1;
					break;
				case g_TAG:
					if (turnoff & 0x00200000)
					{
						last_format &= 0xFFDFFFFF;
						turnoff &= 0xFFDFFFFF;
						drop_tag(tmpoff);
						memcpy(outbuf,"</g>",4);
						outbuf += 4;
					}
					else skip = 1;
					break;
				case b_TAG:
					if (turnoff & 0x00400000)
					{
						last_format &= 0xFFBFFFFF;
						turnoff &= 0xFFBFFFFF;
						drop_tag(tmpoff);
						memcpy(outbuf,"</b>",4);
						outbuf += 4;
					}
					else skip = 1;
					break;
				case c_TAG:
					if (turnoff & 0x00800000)
					{
						last_format &= 0xFF7FFFFF;
						turnoff &= 0xFF7FFFFF;
						drop_tag(tmpoff);
						memcpy(outbuf,"</c>",4);
						outbuf += 4;
					}
					else skip = 1;
					break;
				case m_TAG:
					if (turnoff & 0x01000000)
					{
						last_format &= 0xFEFFFFFF;
						turnoff &= 0xFEFFFFFF;
						drop_tag(tmpoff);
						memcpy(outbuf,"</m>",4);
						outbuf += 4;
					}
					else skip = 1;
					break;
				case y_TAG:
					if (turnoff & 0x02000000)
					{
						last_format &= 0xFDFFFFFF;
						turnoff &= 0xFDFFFFFF;
						drop_tag(tmpoff);
						memcpy(outbuf,"</y>",4);
						outbuf += 4;
					}
					else skip = 1;
					break;
				case k_TAG:
					if (turnoff & 0x04000000)
					{
						last_format &= 0xFBFFFFFF;
						turnoff &= 0xFBFFFFFF;
						drop_tag(tmpoff);
						memcpy(outbuf,"</k>",4);
						outbuf += 4;
					}
					else skip = 1;
					break;
				case w_TAG:
					if (turnoff & 0x08000000)
					{
						last_format &= 0xF7FFFFFF;
						turnoff &= 0xF7FFFFFF;
						drop_tag(tmpoff);
						memcpy(outbuf,"</w>",4);
						outbuf += 4;
					}
					else skip = 1;
					break;
				}
				if (skip)
				{
					tmpoff++;
					off_tag(tagbuf[tagcount-tmpoff]);
				}
			}
			for (i = tagcount-tmpoff; i < tagcount; i++)
			{
				on_tag(tagbuf[i]);
			}
			bitcount = 0;
			allchange = format_now ^ last_format;
			for (i = 0; i < NUM_TAGS; i++) { if (allchange & 1) bitcount++; allchange = allchange >> 1; }
			if (bitcount == 0);
			else if (bitcount == 1)
			{
				if (last_format != format_now)
				{
					add_tag(format_now ^ last_format);
				}
			}
			else
			{
				found = 0;
				stillon = format_now;
				int newtags = bitcount;
				while(bitcount)
				{
#if 0
					if (changebuf[found] == NULL)
					{
						fprintf(stderr,"Internal error\n");
						break;
					}
#endif
					nextchange = *((unsigned int *)&(changebuf[found][1])) ^ stillon;
					if ((nextchange & allchange) == allchange)
					{
						bitchange = stillon ^ last_format;
						if (bitchange & 0x00000001)
						{
							bitcount--;
							tagbuf[tagcount+bitcount] = B_TAG;
						}
						if (bitchange & 0x00000002)
						{
							bitcount--;
							tagbuf[tagcount+bitcount] = EM_TAG;
						}
						if (bitchange & 0x00000004)
						{
							bitcount--;
							tagbuf[tagcount+bitcount] = I_TAG;
						}
						if (bitchange & 0x00000008)
						{
							bitcount--;
							tagbuf[tagcount+bitcount] = PL_TAG;
						}
						if (bitchange & 0x00000010)
						{
							bitcount--;
							tagbuf[tagcount+bitcount] = S_TAG;
						}
						if (bitchange & 0x00000020)
						{
							bitcount--;
							tagbuf[tagcount+bitcount] = TT_TAG;
						}
						if (bitchange & 0x00000040)
						{
							bitcount--;
							tagbuf[tagcount+bitcount] = U0_TAG;
						}
						if (bitchange & 0x00000080)
						{
							bitcount--;
							tagbuf[tagcount+bitcount] = U1_TAG;
						}
						if (bitchange & 0x00000100)
						{
							bitcount--;
							tagbuf[tagcount+bitcount] = U2_TAG;
						}
						if (bitchange & 0x00000200)
						{
							bitcount--;
							tagbuf[tagcount+bitcount] = U3_TAG;
						}
						if (bitchange & 0x00000400)
						{
							bitcount--;
							tagbuf[tagcount+bitcount] = N0_TAG;
						}
						if (bitchange & 0x00000800)
						{
							bitcount--;
							tagbuf[tagcount+bitcount] = N1_TAG;
						}
						if (bitchange & 0x00001000)
						{
							bitcount--;
							tagbuf[tagcount+bitcount] = N2_TAG;
						}
						if (bitchange & 0x00002000)
						{
							bitcount--;
							tagbuf[tagcount+bitcount] = N3_TAG;
						}
						if (bitchange & 0x00004000)
						{
							bitcount--;
							tagbuf[tagcount+bitcount] = N4_TAG;
						}
						if (bitchange & 0x00008000)
						{
							bitcount--;
							tagbuf[tagcount+bitcount] = N5_TAG;
						}
						if (bitchange & 0x00010000)
						{
							bitcount--;
							tagbuf[tagcount+bitcount] = N6_TAG;
						}
						if (bitchange & 0x00020000)
						{
							bitcount--;
							tagbuf[tagcount+bitcount] = N7_TAG;
						}
						if (bitchange & 0x00040000)
						{
							bitcount--;
							tagbuf[tagcount+bitcount] = N8_TAG;
						}
						if (bitchange & 0x00080000)
						{
							bitcount--;
							tagbuf[tagcount+bitcount] = N9_TAG;
						}
						if (bitchange & 0x00100000)
						{
							bitcount--;
							tagbuf[tagcount+bitcount] = r_TAG;
						}
						if (bitchange & 0x00200000)
						{
							bitcount--;
							tagbuf[tagcount+bitcount] = g_TAG;
						}
						if (bitchange & 0x00400000)
						{
							bitcount--;
							tagbuf[tagcount+bitcount] = b_TAG;
						}
						if (bitchange & 0x00800000)
						{
							bitcount--;
							tagbuf[tagcount+bitcount] = c_TAG;
						}
						if (bitchange & 0x01000000)
						{
							bitcount--;
							tagbuf[tagcount+bitcount] = m_TAG;
						}
						if (bitchange & 0x02000000)
						{
							bitcount--;
							tagbuf[tagcount+bitcount] = y_TAG;
						}
						if (bitchange & 0x04000000)
						{
							bitcount--;
							tagbuf[tagcount+bitcount] = k_TAG;
						}
						if (bitchange & 0x08000000)
						{
							bitcount--;
							tagbuf[tagcount+bitcount] = w_TAG;
						}
					}
					else if ((nextchange & allchange) == 0) found++;
					else
					{
						nextoff = (nextchange & allchange);
						if (nextoff & 0x00000001)
						{
							bitcount--;
							tagbuf[tagcount+bitcount] = B_TAG;
							allchange &= 0xFFFFFFFE;
						}
						if (nextoff & 0x00000002)
						{
							bitcount--;
							tagbuf[tagcount+bitcount] = EM_TAG;
							allchange &= 0xFFFFFFFD;
						}
						if (nextoff & 0x00000004)
						{
							bitcount--;
							tagbuf[tagcount+bitcount] = I_TAG;
							allchange &= 0xFFFFFFFB;
						}
						if (nextoff & 0x00000008)
						{
							bitcount--;
							tagbuf[tagcount+bitcount] = PL_TAG;
							allchange &= 0xFFFFFFF7;
						}
						if (nextoff & 0x00000010)
						{
							bitcount--;
							tagbuf[tagcount+bitcount] = S_TAG;
							allchange &= 0xFFFFFFEF;
						}
						if (nextoff & 0x00000020)
						{
							bitcount--;
							tagbuf[tagcount+bitcount] = TT_TAG;
							allchange &= 0xFFFFFFDF;
						}
						if (nextoff & 0x00000040)
						{
							bitcount--;
							tagbuf[tagcount+bitcount] = U0_TAG;
							allchange &= 0xFFFFFFBF;
						}
						if (nextoff & 0x00000080)
						{
							bitcount--;
							tagbuf[tagcount+bitcount] = U1_TAG;
							allchange &= 0xFFFFFF7F;
						}
						if (nextoff & 0x00000100)
						{
							bitcount--;
							tagbuf[tagcount+bitcount] = U2_TAG;
							allchange &= 0xFFFFFEFF;
						}
						if (nextoff & 0x00000200)
						{
							bitcount--;
							tagbuf[tagcount+bitcount] = U3_TAG;
							allchange &= 0xFFFFFDFF;
						}
						if (nextoff & 0x00000400)
						{
							bitcount--;
							tagbuf[tagcount+bitcount] = N0_TAG;
							allchange &= 0xFFFFFBFF;
						}
						if (nextoff & 0x00000800)
						{
							bitcount--;
							tagbuf[tagcount+bitcount] = N1_TAG;
							allchange &= 0xFFFFF7FF;
						}
						if (nextoff & 0x00001000)
						{
							bitcount--;
							tagbuf[tagcount+bitcount] = N2_TAG;
							allchange &= 0xFFFFEFFF;
						}
						if (nextoff & 0x00002000)
						{
							bitcount--;
							tagbuf[tagcount+bitcount] = N3_TAG;
							allchange &= 0xFFFFDFFF;
						}
						if (nextoff & 0x00004000)
						{
							bitcount--;
							tagbuf[tagcount+bitcount] = N4_TAG;
							allchange &= 0xFFFFBFFF;
						}
						if (nextoff & 0x00008000)
						{
							bitcount--;
							tagbuf[tagcount+bitcount] = N5_TAG;
							allchange &= 0xFFFF7FFF;
						}
						if (nextoff & 0x00010000)
						{
							bitcount--;
							tagbuf[tagcount+bitcount] = N6_TAG;
							allchange &= 0xFFFEFFFF;
						}
						if (nextoff & 0x00020000)
						{
							bitcount--;
							tagbuf[tagcount+bitcount] = N7_TAG;
							allchange &= 0xFFFDFFFF;
						}
						if (nextoff & 0x00040000)
						{
							bitcount--;
							tagbuf[tagcount+bitcount] = N8_TAG;
							allchange &= 0xFFFBFFFF;
						}
						if (nextoff & 0x00080000)
						{
							bitcount--;
							tagbuf[tagcount+bitcount] = N9_TAG;
							allchange &= 0xFFF7FFFF;
						}
						if (nextoff & 0x00100000)
						{
							bitcount--;
							tagbuf[tagcount+bitcount] = r_TAG;
							allchange &= 0xFFEFFFFF;
						}
						if (nextoff & 0x00200000)
						{
							bitcount--;
							tagbuf[tagcount+bitcount] = g_TAG;
							allchange &= 0xFFDFFFFF;
						}
						if (nextoff & 0x00400000)
						{
							bitcount--;
							tagbuf[tagcount+bitcount] = b_TAG;
							allchange &= 0xFFBFFFFF;
						}
						if (nextoff & 0x00800000)
						{
							bitcount--;
							tagbuf[tagcount+bitcount] = c_TAG;
							allchange &= 0xFF7FFFFF;
						}
						if (nextoff & 0x01000000)
						{
							bitcount--;
							tagbuf[tagcount+bitcount] = m_TAG;
							allchange &= 0xFEFFFFFF;
						}
						if (nextoff & 0x02000000)
						{
							bitcount--;
							tagbuf[tagcount+bitcount] = y_TAG;
							allchange &= 0xFDFFFFFF;
						}
						if (nextoff & 0x04000000)
						{
							bitcount--;
							tagbuf[tagcount+bitcount] = k_TAG;
							allchange &= 0xFBFFFFFF;
						}
						if (nextoff & 0x08000000)
						{
							bitcount--;
							tagbuf[tagcount+bitcount] = w_TAG;
							allchange &= 0xF7FFFFFF;
						}
						found++;
						stillon = allchange;
					}
				}
				for (i = 0; i < newtags; i++)
				{
					on_tag(tagbuf[tagcount+i]);
				}
				tagcount += newtags;
			}
		}
		*outbuf++ = *inbuf;
		last_format = format_now;
		inbuf += 5;
	}
	fwrite(outstart+1,1,outbuf-outstart-2,stdout);
	return 0;
}
